library test.encode;

import 'package:test/test.dart';
import 'package:jaguar_jwt/jaguar_jwt.dart';
import 'package:dart_jwt/dart_jwt.dart';

main() {
  group('Encoding', () {
    test('Nopayload', () {
      final sig = new JwaSymmetricKeySignatureContext('secret');
      final encoded = new JwtAuthenticationContext(sig, 'teja',
              audience: ["admin", "students"])
          .encodeForSubject("1234567890", issuedAt: new DateTime(2016, 12, 16));
      expect(encoded,
          r'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwiaXNzIjoidGVqYSIsImF1ZCI6WyJhZG1pbiIsInN0dWRlbnRzIl0sImlhdCI6MTQ4MTg0MjgwMCwiZXhwIjoxNDgxOTI5MjAwLCJwYXlsb2FkIjp7fX0.BpIUNh5Itz4m2UYsY9iHpd-DQ3amGrDNvf9jH_j1snw');
    });

    test('With payload', () {
      final sig = new JwaSymmetricKeySignatureContext('secret');
      final encoded = new JwtAuthenticationContext(sig, 'teja',
              audience: ["admin", "students"])
          .encodeForSubject("1234567890",
              issuedAt: new DateTime(2016, 12, 16), payload: {"k": "v"});
      expect(encoded,
          r"eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJzdWIiOiIxMjM0NTY3ODkwIiwiaXNzIjoidGVqYSIsImF1ZCI6WyJhZG1pbiIsInN0dWRlbnRzIl0sImlhdCI6MTQ4MTg0MjgwMCwiZXhwIjoxNDgxOTI5MjAwLCJwYXlsb2FkIjp7ImsiOiJ2In19.gVsmxfJFJRcr501e9wspUVlbZJYfuGVt6PDoZ-wcNOs");
    });
  });
}
